;*** Misc stuff ***

Tasm2Asciiz_ PROC
;in: edi=pointer to string
push es
mov ax,ds
mov es,ax
mov cx,255
mov al,'$'
repne scasb
mov al,0
dec edi
mov es:[edi],al
pop es
ret
Tasm2Asciiz_ ENDP


Asciiz2Tasm_ PROC
;in: edi=pointer to string.
push es
mov ax,ds
mov es,ax
mov cx,255
mov al,0
repne scasb
mov al,'$'
dec edi
mov es:[edi],al
pop es
ret
Asciiz2Tasm_ ENDP


;INT StrCmp(CHAR *string1,CHAR *string2,INT strlen)
; parm [esi][edi][ecx]
; value[eax]		(0 = OK)
StrCmp PROC
local funcvalue:dword
 pusha
 xor eax,eax
 SCmp_@loop:
  lodsb
  sub al,[edi]
  inc edi
  cmp al,0
  jne SCmp_@break
  dec ecx
 jnz SCmp_@loop
 SCmp_@break:
 mov funcvalue,eax
 popa
 mov eax,funcvalue
 ret
StrCmp ENDP
 


StrCopy_ PROC
;in: esi=source pointer. edi=dest pointer.
  push es
  push esi
  xor ecx,ecx
  mov ax,ds
  mov es,ax
  mov cx,255
  mov al,'$'
  push edi
  mov edi,esi
  repne scasb
  mov dx,255
  sub dl,cl
  mov cx,dx
  pop edi
  rep movsb
  pop eax
  sub esi,eax
  mov StrCopy__bytes_,eax  
  pop es
  ret
StrCopy_ ENDP


StrConcat_ PROC
;in: esi=pointer to string 1. edi=pointer to string 2.
  push es
  mov ax,ds
  mov es,ax
  push edi
  mov edi,OFFSET StrConcat__str_
  call StrCopy_
  dec edi
  pop esi
  call StrCopy_
  pop es
  ret
StrConcat_ ENDP


Format2Asciiz_ PROC
;in: esi=source pointer.
  push es
  xor ecx,ecx
  mov ax,ds
  mov es,ax
  mov cx,255
  mov al,'$'
  mov edi,esi
  repne scasb
  mov dx,255
  sub dl,cl
  mov cx,dx
  dec cx
  mov edi,OFFSET sysStr01_
  Format2Asciiz_@loop:
    mov al,[esi]
    cmp al,'\'
    jne Format2Asciiz_@not_escape
    dec cx
    dec cx
    inc esi
    mov al,[esi]
    cmp al,'n'
    jne Format2Asciiz_@elsif_al_is_bkslash
      mov ax,0d0ah
      mov es:[edi],ah
      mov es:[edi+1],al
      add edi,2
      inc esi
      jmp Format2Asciiz_@endif
    Format2Asciiz_@elsif_al_is_bkslash:
      cmp al,'\'
      jne Format2Asciiz_@endif
      mov es:[edi],al
      inc edi
      inc esi
    Format2Asciiz_@endif:
    jmp Format2Asciiz_@loop_next
    Format2Asciiz_@not_escape:
    mov es:[edi],al
    inc edi
    inc esi
    dec cx
    Format2Asciiz_@loop_next:
    cmp cx,0
  jg Format2Asciiz_@loop
  mov al,0
  mov es:[edi],al
  pop es
  ret
Format2Asciiz_ ENDP


Sprint_ PROC
;in: edi=pointer to string.
;  push esi
;  push edi
  xor eax,eax
  mov eax,Sprint__value
  mov Sprint__temp_,eax
  mov esi,OFFSET Sprint__str_
  mov Sprint__subZero_,0
  cmp Sprint__signed_,0
  je Sprint__@above_zero
  cmp eax,0			;IF value<0 THEN
  jnl Sprint__@above_zero
    neg eax
    mov Sprint__temp_,eax
    mov Sprint__subZero_,1
  Sprint__@above_zero:		;END IF
  inc esi
  mov Sprint__div_,1000000000
  mov cx,2
  Sprint__@loop:
    mov eax,Sprint__temp_
    mov ebx,Sprint__div_
    xor edx,edx
    div ebx			;al=FLOOR(value/printDiv)
    add al,48
    mov ds:[esi],al
    inc esi
    sub al,48
    mul ebx
    sub Sprint__temp_,eax
    mov eax,Sprint__div_
    mov ebx,10
    xor edx,edx
    div ebx		
    mov Sprint__div_,eax		;printDiv=printDiv/10
    inc cx
    cmp cx,12
  jne Sprint__@loop
  mov esi,OFFSET Sprint__str_
  inc esi
  mov cx,2
  add cl,Sprint__minLen_
  dec cx
  Sprint__@remove_padding:
    mov al,ds:[esi]
    cmp al,48
    jne Sprint__@remove_padding_done
    inc cx
    cmp cx,12
    jge Sprint__@remove_padding_done
    inc esi
  jmp Sprint__@remove_padding
  Sprint__@remove_padding_done:
  cmp Sprint__subZero_,1
  jne Sprint__@above_zero_2
    dec esi
    mov al,'-'
    mov ds:[esi],al
  Sprint__@above_zero_2:
;  mov edi,OFFSET sysStr01_
  cmp Sprint__maxLen_,0
  je Sprint__@no_maxLen
  push es
  mov ax,ds
  mov es,ax
  xor ecx,ecx
  mov cl,Sprint__maxLen_
  rep movsb
  mov BYTE PTR ds:[edi],36
  inc edi
  pop es
  jmp Sprint__@return
  Sprint__@no_maxLen:
  call StrCopy_
  Sprint__@return: 
;  pop edi
;  pop esi
  ret
Sprint_ ENDP


SprintHex_ PROC
;in: pointer to string.
  xor eax,eax
  mov eax,SprintHex__value
  mov SprintHex__temp_,eax
  mov esi,OFFSET SprintHex__str_
  mov SprintHex__subZero_,0
  ;cmp eax,0			;IF value<0 THEN
  ;jnl SprintHex__@above_zero
  ;  neg eax
  ;  mov SprintHex__temp_,eax
  ;  mov SprintHex__subZero_,1
  SprintHex__@above_zero:	;END IF
  inc esi
  inc esi
  mov SprintHex__mask_,0f0000000h
  mov cx,28
  SprintHex__@loop:
    mov eax,SprintHex__temp_
    and eax,SprintHex__mask_
    shr eax,cl
    mov bl,al
    cmp bl,10
    jb SprintHex__@below_10
    add bl,7			;to get letters ('a'..'f')
    SprintHex__@below_10:
    add bl,48
    mov ds:[esi],bl
    inc esi
    shl eax,cl
    sub SprintHex__temp_,eax
    mov eax,SprintHex__mask_
    shr eax,4
    mov SprintHex__mask_,eax		;printDiv=printDiv/10
    sub cx,4
    cmp cx,0
  jge SprintHex__@loop
  mov esi,OFFSET SprintHex__str_
  inc esi
  inc esi
  mov cx,3
  SprintHex__@remove_padding:
    mov al,ds:[esi]
    cmp al,'0'
    jne SprintHex__@remove_padding_done
    inc cx
    cmp cx,11
    je SprintHex__@remove_padding_done
    inc esi
  jmp SprintHex__@remove_padding
  SprintHex__@remove_padding_done:
  dec esi
  mov al,'0'
  mov ds:[esi],al
  cmp SprintHex__subZero_,1
  jne SprintHex__@above_zero_2
    dec esi
    mov al,'-'
    mov ds:[esi],al
  SprintHex__@above_zero_2:
  call StrCopy_
  ret
SprintHex_ ENDP


SprintBin_ PROC
;in: edi=pointer to string
  xor eax,eax
  mov eax,SprintBin__value
  mov SprintBin__temp_,eax
  mov esi,OFFSET SprintBin__str_
  mov SprintBin__subZero_,0
  cmp eax,0			;IF value<0 THEN
  jnl SprintBin__@above_zero
    neg eax
    mov SprintBin__temp_,eax
    mov SprintBin__subZero_,1
  SprintBin__@above_zero:		;END IF
  inc esi
  mov SprintBin__mask_,080000000h
  mov cx,31
  SprintBin__@loop:
    mov eax,SprintBin__temp_
    and eax,SprintBin__mask_
    shr eax,cl
    mov bl,al
    add bl,48
    mov ds:[esi],bl
    inc esi
    shl eax,cl
    sub SprintBin__temp_,eax
    mov eax,SprintBin__mask_
    shr eax,1
    mov SprintBin__mask_,eax		;printDiv=printDiv/10
    dec cx
    cmp cx,0
  jge SprintBin__@loop
  mov esi,OFFSET SprintBin__str_
  inc esi
  mov cx,2
  SprintBin__@remove_padding:
    mov al,ds:[esi]
    cmp al,'0'
    jne SprintBin__@remove_padding_done
    inc cx
    cmp cx,34
    je SprintBin__@remove_padding_done
    inc esi
  jmp SprintBin__@remove_padding
  SprintBin__@remove_padding_done:
  cmp SprintBin__subZero_,1
  jne SprintBin__@above_zero_2
    dec esi
    mov al,'-'
    mov ds:[esi],al
  SprintBin__@above_zero_2:
  call StrCopy_
  ret
SprintBin_ ENDP


SprintFloat_ PROC
;in: edi=pointer to string.
  mov eax,SprintFloat__value
  cmp eax,0
  je SprintFloat__@its_zero
  mov SprintFloat__subZero_,0
  mov ebx,eax
  and eax,080000000h
  cmp eax,0
  je SprintFloat__@above_zero
    mov SprintFloat__subZero_,1
  SprintFloat__@above_zero:
  mov eax,ebx
  and eax,7f800000h
  shr eax,23
  sub eax,127
  mov SprintFloat__exp_,al
  mov eax,ebx
  and eax,007fffffh
  mov SprintFloat__mantissa_,eax
  cmp SprintFloat__exp_,0
  jng SprintFloat__@test_exp_below_zero
    mov cl,SprintFloat__exp_
    mov eax,1
    shl eax,cl
    mov cl,23
    sub cl,SprintFloat__exp_
    mov edx,SprintFloat__mantissa_
    shr edx,cl				;shift mantissa by 23-exponent
    or eax,edx
    mov SprintFloat__int_,eax
    mov cl,SprintFloat__exp_
    mov eax,SprintFloat__mantissa_
    shl eax,cl				;throw away the bits that went into the integer part
    and eax,007fffffh			;only keep the 23 lower bits 
    mov SprintFloat__frac_,eax
  jmp SprintFloat__@exp_fix_done
    SprintFloat__@test_exp_below_zero:
    cmp SprintFloat__exp_,0
    jnl SprintFloat__@exp_fix_done
    mov SprintFloat__int_,0
    mov eax,SprintFloat__mantissa_
    shr eax,1
    or eax,00400000h
    mov cl,SprintFloat__exp_
    neg cl
    dec cl
    shr eax,cl
    mov SprintFloat__frac_,eax
  SprintFloat__@exp_fix_done:
;  mov esi,OFFSET SprintFloat__str_
  cmp SprintFloat__subZero_,0
  je SprintFloat__@above_zero_2
    mov al,'-'
    mov ds:[edi],al
    inc edi
  SprintFloat__@above_zero_2:
;  inc esi
  ;*** convert fractional value ***
  mov cx,23
  mov eax,500000000		;pseudo for 0.500000000
  mov ebx,00400000h		;mask. begin at bit 23
  mov SprintFloat__fixedFrac_,0
  SprintFloat__@frac_fix:
    mov edx,SprintFloat__frac_
    and edx,ebx
    cmp edx,0
    je SprintFloat__@bit_not_set
    add SprintFloat__fixedFrac_,eax
    SprintFloat__@bit_not_set:
    shr eax,1
    shr ebx,1
    dec cx
  jnz SprintFloat__@frac_fix
  mov eax,SprintFloat__int_
  mov Sprint__value,eax
  call Sprint_
  dec edi
  mov al,'.'
  mov ds:[edi],al
  inc edi
  mov eax,SprintFloat__fixedFrac_
  mov Sprint__value,eax
  mov al,SprintFloat__minLen_
  mov Sprint__maxLen_,al
  call Sprint_
  mov Sprint__maxLen_,0
  jmp SprintFloat__@return
  SprintFloat__@its_zero:
    mov esi,OFFSET SprintFloat__zeroStr_
    call StrCopy_
  SprintFloat__@return:
  ret
SprintFloat_ ENDP



Sprintf_ PROC
  pusha
  mov ax,ds
  mov es,ax
  cmp Sprintf__numParams_,0
  jne Sprintf__@numParams_not_zero
  mov esi,Sprintf__strPtr
  mov edi,OFFSET sysStr01_
  call StrCopy_
  jmp Sprintf__@done
  Sprintf__@numParams_not_zero:
  mov al,'$'
  mov cx,255
  mov edi,Sprintf__strPtr
  repne scasb
  inc cx
  mov dx,255
  sub dl,cl
  mov Sprintf__strLen_,dl
  mov esi,Sprintf__strPtr
  mov Sprintf__lastStrPos_,esi
  mov Sprintf__strPos_,1
  mov ebx,OFFSET Sprintf__params
  mov Sprintf__paramPtr_,ebx
  mov edi,OFFSET sysStr01_
  Sprintf__@loop:
    mov al,[esi]
    cmp al,'%'
    jne Sprintf__@no_format_sign
;    mov al,'$'
;    mov [esi],al
;    mov eax,esi
;    sub eax,Sprintf__lastStrPos_
;    jz Sprintf__@dont_print_this_1
;    mov edx,Sprintf__lastStrPos_
;    mov ah,09h
;    int 21h
;    Sprintf__@dont_print_this_1:
    inc esi
    mov al,[esi]
    inc esi
    Sprintf__@if_al_is_d:
      cmp al,'d'
      jne Sprintf__@elsif_al_is_percent
      mov Sprint__signed_,1
      mov Sprint__minLen_,1
      Sprintf__@is_dec_param:
      mov ebx,Sprintf__paramPtr_
      add Sprintf__paramPtr_,4
      mov eax,ds:[ebx]
      mov Sprint__value,eax
      push esi
      call Sprint_
      pop esi
      dec edi
      jmp Sprintf__@endif_al_is_d
    Sprintf__@elsif_al_is_percent:
      cmp al,'%'
      jne Sprintf__@elsif_al_is_h
      mov ds:[edi],al       
      inc edi
      jmp Sprintf__@endif_al_is_d
    Sprintf__@elsif_al_is_h:
      cmp al,'h'
      jne Sprintf__@elsif_al_is_b
      mov SprintHex__minLen_,1
      Sprintf__@is_hex_param:
      mov ebx,Sprintf__paramPtr_
      add Sprintf__paramPtr_,4
      mov eax,ds:[ebx]
      mov SprintHex__value,eax
      push esi
      call SprintHex_
      pop esi
      dec edi
      jmp Sprintf__@endif_al_is_d
    Sprintf__@elsif_al_is_b:
      cmp al,'b'
      jne Sprintf__@elsif_al_is_f
      mov SprintBin__minLen_,1
      Sprintf__@is_bin_param:
      mov ebx,Sprintf__paramPtr_
      add Sprintf__paramPtr_,4
      mov eax,ds:[ebx]
      mov SprintBin__value,eax
      push esi
      call SprintBin_
      pop esi
      dec edi
      jmp Sprintf__@endif_al_is_d
    Sprintf__@elsif_al_is_f:
      cmp al,'f'
      jne Sprintf__@elsif_al_is_u
      mov SprintFloat__minLen_,1
      Sprintf__@is_float_param:
      mov Sprint__minLen_,1
      mov ebx,Sprintf__paramPtr_
      add Sprintf__paramPtr_,4
      mov eax,ds:[ebx]
      mov SprintFloat__value,eax
      push esi
      call SprintFloat_       
      pop esi
      dec edi
      jmp Sprintf__@endif_al_is_d
    Sprintf__@elsif_al_is_u:
      cmp al,'u'
      jne Sprintf__@elsif_len_spec
      mov al,[esi]
      inc esi
      cmp al,'d'
      jne Sprintf__@elsif_unsigned_h
        mov Sprint__signed_,0
        inc Sprintf__strPos_ 
        jmp Sprintf__@is_dec_param
    Sprintf__@elsif_unsigned_h:
      cmp al,'h'
      jne Sprintf__@elsif_unsigned_b
        inc Sprintf__strPos_ 
        jmp Sprintf__@is_hex_param
    Sprintf__@elsif_unsigned_b:
      cmp al,'b'
      jne Sprintf__@endif_al_is_d
        inc Sprintf__strPos_ 
        jmp Sprintf__@is_bin_param
    Sprintf__@elsif_len_spec:
     cmp al,'1'
     jb Sprintf__@endif_al_is_d
     cmp al,'9'
     jg Sprintf__@endif_al_is_d

      sub al,48
      mov bl,al
      mov al,[esi]
      inc esi
      cmp al,'d'
      jne Sprintf__@elsif_len_spec_h
        mov Sprint__minLen_,bl
        inc Sprintf__strPos_ 
        jmp Sprintf__@is_dec_param
    Sprintf__@elsif_len_spec_h:
      cmp al,'h'
      jne Sprintf__@elsif_len_spec_b
        mov SprintHex__minLen_,bl
        inc Sprintf__strPos_ 
        jmp Sprintf__@is_hex_param
    Sprintf__@elsif_len_spec_b:
      cmp al,'b'
      jne Sprintf__@elsif_len_spec_f
        mov SprintBin__minLen_,bl
        inc Sprintf__strPos_ 
        jmp Sprintf__@is_bin_param
    Sprintf__@elsif_len_spec_f:
      cmp al,'f'
      jne Sprintf__@endif_al_is_d
        mov SprintFloat__minLen_,bl
        inc Sprintf__strPos_ 
        jmp Sprintf__@is_float_param       

    Sprintf__@endif_al_is_d:
    mov Sprintf__lastStrPos_,esi
    add Sprintf__strPos_,2
    jmp Sprintf__@loop_next
    Sprintf__@no_format_sign:
    cmp al,'\'
    jne Sprintf__@no_escape_sign
;    mov al,'$'
;    mov [esi],al
;    mov eax,esi
;    sub eax,Sprintf__lastStrPos_
;    jz Sprintf__@dont_print_this_2
;    mov edx,Sprintf__lastStrPos_
;    mov ah,09h
;    int 21h
;    Sprintf__@dont_print_this_2:
    inc esi
    mov al,[esi]
    inc esi
    Sprintf__@if_al_is_n:
      cmp al,'n'
      jne Sprintf__@elsif_al_is_backslash
;      mov edx,OFFSET sysLF_
;      mov ah,09h
;      int 21h
       mov ax,0d0ah
       mov ds:[edi],ah
       inc edi
       mov ds:[edi],al
       inc edi
      jmp Sprintf__@endif_al_is_n
    Sprintf__@elsif_al_is_backslash:
      cmp al,'\'
      jne Sprintf__@endif_al_is_n
      mov ds:[edi],al
      inc edi 
    Sprintf__@endif_al_is_n:
    mov Sprintf__lastStrPos_,esi
    add Sprintf__strPos_,2
    jmp Sprintf__@loop_next
    Sprintf__@no_escape_sign:
    inc esi
    mov ds:[edi],al
    inc edi    
    inc Sprintf__strPos_
    Sprintf__@loop_next:
    mov al,Sprintf__strPos_
    cmp al,Sprintf__strLen_
  jbe Sprintf__@loop 
  Sprintf__@done:
;  mov eax,Sprintf__lastStrPos_
;  cmp eax,esi
;  je Sprintf__@dont_print_this_3
;  mov edx,Sprintf__lastStrPos_
;  mov ah,09h
;  int 21h
;  Sprintf__@dont_print_this_3:
  mov al,'$'
  mov ds:[edi],al 
  popa
  ret
Sprintf_ ENDP


Sputs_ PROC
;in: edi=pointer to string.
  push es
  push edi
  mov ax,ds
  mov es,ax
  mov al,'$'
  mov cx,255
  mov edi,Sputs__strPtr
  repne scasb
  inc cx
  mov dx,255
  sub dl,cl
  mov Sputs__strLen_,dl
  mov esi,Sputs__strPtr
  mov Sputs__lastStrPos_,esi
  mov Sputs__strPos_,1
  pop edi
  Sputs__@loop:
    mov al,[esi]
    cmp al,'\'
    jne Sputs__@no_escape_sign
    inc esi
    mov al,[esi]
    inc esi
    Sputs__@if_al_is_n:
      cmp al,'n'
      jne Sputs__@elsif_al_is_backslash
      mov ax,0d0ah
      mov ds:[edi],ah
      inc edi
      mov ds:[edi],al
      inc edi 
      jmp Sputs__@endif_al_is_n
    Sputs__@elsif_al_is_backslash:
      cmp al,'\'
      jne Sputs__@endif_al_is_n
      mov [edi],al
      inc edi
    Sputs__@endif_al_is_n:
    mov Sputs__lastStrPos_,esi
    add Sputs__strPos_,2
    jmp Sputs__@loop_next
    Sputs__@no_escape_sign:
    mov ds:[edi],al
    inc edi
    inc esi    
    inc Sputs__strPos_
    Sputs__@loop_next:
    mov al,Sputs__strPos_
    cmp al,Sputs__strLen_
  jbe Sputs__@loop 
  Sputs__@done:
  mov BYTE PTR ds:[edi],36
  pop es
  ret
Sputs_ ENDP


GetCursor_ PROC
  mov bh,0
  mov ah,3
  int 10h
  ret
GetCursor_ ENDP


SetCursor_ PROC
  mov bh,0
  mov ah,2
  int 10h
  ret
SetCursor_ ENDP

;*** Math stuff ***

Abs_ PROC
 mov eax,Abs__value
 mov edx,eax
 sar edx,15
 xor eax,edx
 sub eax,edx
 mov _Abs_,eax
 ret
Abs_ ENDP


.data
StrCopy__bytes_		dd ?

StrConcat__str_		db 255 dup (?)

Sprint__value		dd ?
Sprint__temp_		dd ?
Sprint__div_		dd ?
Sprint__str_		db 11 DUP (?), '$'
Sprint__subZero_ 	db ?
Sprint__signed_		db 0
Sprint__minLen_		db 2
Sprint__maxLen_		db 0

SprintHex__value	dd ?
SprintHex__temp_	dd ?
SprintHex__mask_	dd ?
SprintHex__str_		db 10 DUP (?), '$'
SprintHex__subZero_	db ?
SprintHex__minLen_	db 2

SprintBin__value	dd ?
SprintBin__temp_	dd ?
SprintBin__mask_	dd ?
SprintBin__str_		db 33 DUP (?), '$'
SprintBin__subZero_	db ?
SprintBin__minLen_	db 2

SprintFloat__value	dd ?
;SprintFloat__str_	db 20 DUP (?), '$'
SprintFloat__subZero_	db ?
SprintFloat__exp_	db ?
SprintFloat__mantissa_	dd ?
SprintFloat__int_	dd ?
SprintFloat__frac_	dd ?
SprintFloat__fixedFrac_	dd ?
SprintFloat__zeroStr_	db '0.0','$'
SprintFloat__minLen_	db 2

Sprintf__strPtr		dd ?
Sprintf__params		dd 10 dup (?)	;param 1,2,3..10
Sprintf__paramPtr_	dd ?
Sprintf__numParams_	db 1
Sprintf__strlen_	db ?
Sprintf__strPos_	db ?
Sprintf__lastStrPos_	dd ?

Sputs__strPtr		dd ?
Sputs__strlen_		db ?
Sputs__strPos_		db ?
Sputs__lastStrPos_	dd ?

Abs__value		dd ?
_Abs_			dd ?

sysStr01_		db 255 dup (?)
sysStr02_		db 255 dup (?)
sysLF_			db 13,10,'$'
TextAttribs_		db 07h



