;UINTx2 malloc(UINT Bytes)	(returns 2 unsigned integers)
; parm[eax]
; value[edi][ebx]
;(edi will be a pointer on success (or 0 on failure). ebx will be a handle to the memory
; block on success (used with free()) ).  
malloc PROC
 xor ebx,ebx 
 xor ecx,ecx
 mov cx,ax
 shr eax,16
 mov bx,ax
 mov eax,0501h
 int 31h
 jc malloc_@failed
 mov ax,si
 shl eax,16
 mov ax,di
 mov edx,eax
 mov ax,bx
 shl eax,16
 mov ax,cx
 mov edi,eax
 mov ebx,edx 
 jmp malloc_@return
 malloc_@failed:
 mov edi,0
 mov ebx,0
 malloc_@return:
 ret
malloc ENDP


;VOID free(UINT handle)
; parm[ebx]
free PROC
 mov _free,0
 cmp ebx,0
 je free_@return	;only free valid blocks 
 mov di,bx 
 shr ebx,16
 mov si,bx
 mov eax,0502h
 int 31h
 jnc free_@return
  mov _free,1
 free_@return:
 ret
free ENDP


.data
 _free db 0
