; Minimal mode 19 (XIX) gfx lib
; By Mic, 2000



;VOID gfx_mode(UINT mode)
; parm[eax]
gfx_mode PROC
 int 10h
 ret
gfx_mode ENDP


;VOID clear_screen(VOID *dest,UCHAR color)
; parm[edi][al]
;!note! The target screen must be 64000 bytes in size (320*200)
clear_screen PROC
 mov ah,al
 mov ecx,32000
 rep stosw
 ret
clear_screen ENDP


;VOID copy_screen(VOID *dest,VOID *src)
; parm[edi][esi]
;!note! Both screens must be 64000 bytes in size (320*200)
copy_screen PROC
 mov ecx,16000
 rep movsd
 ret
copy_screen ENDP


;VOID wait_vrt(VOID)
wait_vrt PROC
 mov edx,986
 wvrt_@lbl1:
 in ax,dx
 and al,8
 jnz wvrt_@lbl1
 wvrt_@lbl2:
 in ax,dx
 and al,8
 jz wvrt_@lbl2
 ret
wait_vrt ENDP


;VOID set_pal(PALETTE *pal)
; parm[esi]
;(a PALETTE pointer is simply a pointer to a length-768 array of bytes)
set_pal PROC
 mov ecx,0
 set_pal_@loop:
  mov eax,ecx
  mov edx,03C8h
  out dx,al
  inc edx
  lodsb
  out dx,al
  lodsb
  out dx,al
  lodsb
  out dx,al
  inc ecx
  cmp ecx,256
 jne set_pal_@loop
 ret
set_pal ENDP


.data
 _VGA_		EQU 0A0000h

