
match_fast PROC
 xor ebp,ebp
 xor edi,edi
 mov esi,OFFSET match_pal
 mf_@loop:
  xor eax,eax
  xor ebx,ebx
  mov eax,refR
  sub eax,ds:[esi + edi]
  add edi,4
  mov edx,eax
  sar edx,15	
  xor eax,edx
  sub eax,edx
  mov difRsqr,eax
  mov eax,refG	
  sub eax,ds:[esi + edi]
  add edi,4
  mov edx,eax
  sar edx,15
  xor eax,edx
  sub eax,edx
  mov difGsqr,eax
  mov eax,refB	
  sub eax,ds:[esi + edi]
  add edi,4
  mov edx,eax
  sar edx,15
  xor eax,edx
  sub eax,edx
  add eax,difGsqr
  add eax,difRsqr
  mov ebx,eax
  imul ebx
  mov difBsqr,eax
  cmp eax,0
  jne mf_@not_perfect_match
   mov match8bit,ebp
   ret
  mf_@not_perfect_match:
  cmp eax,min_vector
  jge mf_@no_min
   mov min_vector,eax
   mov match8bit,ebp
  mf_@no_min:
  ;add esi,12
  inc ebp
  cmp ebp,255
  jg mf_@done
 jmp mf_@loop
 mf_@done:
 ret
match_fast ENDP



find_rgb PROC
 pusha
 mov match8bit,0
 mov min_vector,13107200
; cmp eax,MATCH_AFFINE
; jne frgb_@elsif_EXACT
  call match_fast
;  jmp frgb_@endif
; frgb_@elsif_EXACT:
; cmp eax,MATCH_EXACT
; jne frgb_@unknown
;  call match_exact_
;  jmp frgb_@endif
; frgb_@unknown:
;  mov match8bit,0
; frgb_@endif:
 popa
 mov eax,match8bit
 ret
find_rgb ENDP
 

;INT create_mixtable(VOID *mem,PALETTE *pal1,PALETTE *pal2,PALETTE *pal_used,DWORD method)
; parm[edi][ebx][edx][esi][eax]
; value[eax]
create_mixtable PROC
;local matchmethod:dword
; mov matchmethod,eax
 pusha
 push edi
 mov edi,OFFSET match_pal
 mov ecx,0
 and eax,255
 poke_pal:
  lodsb
  mov ds:[edi + ecx*4],eax
  inc ecx
  cmp ecx,768
 jne poke_pal
 pop edi
 mov ebp,0
 mixtb_loop:
  push edx
  push ebp
  mov ebp,0
  mixtb_loop_level2:
   xor eax,eax
   mov al,ds:[ebx]
   mov cl,ds:[edx]
   shr al,1
   shr cl,1
   add al,cl
   mov refR,eax
   mov al,ds:[ebx + 1]
   mov cl,ds:[edx + 1]
   shr al,1
   shr cl,1
   add al,cl
   mov refG,eax
   mov al,ds:[ebx + 2]
   mov cl,ds:[edx + 2]
   shr al,1
   shr cl,1
   add al,cl
   mov refB,eax
   add edx,3
   ;mov eax,matchmethod
   call find_rgb
   mov ds:[edi],al
   inc edi
   inc ebp
   cmp ebp,256
  jne mixtb_loop_level2
  pop ebp
  pop edx
  add ebx,3
  inc ebp
  cmp ebp,256
 jne mixtb_loop 
 popa
 mov eax,0
 ret
create_mixtable ENDP


;VOID generate_332_palette(PALETTE *pal)
; parm[edi]
generate_332_palette PROC
 pusha
 mov ecx,0
 g332p_@loop:
  mov eax,ecx
  shr eax,5
  and eax,7
  mov ebx,63
  mul ebx
  mov ebx,7
  div ebx
  and eax,63
  mov [edi],al
  inc edi
  mov eax,ecx
  shr eax,2
  and eax,7
  mov ebx,63
  mul ebx
  mov ebx,7
  div ebx
  and eax,63
  mov [edi],al
  inc edi
  mov eax,ecx
  and eax,3
  mov ebx,63
  mul ebx
  mov ebx,3
  div ebx
  and eax,63
  mov [edi],al
  inc edi
  inc ecx
  cmp ecx,256
 jne g332p_@loop
 popa
 mov al,0
 mov [edi],al
 mov [edi+1],al
 mov [edi+2],al
 mov [edi+763],al
 mov al,63
 mov [edi+762],al
 mov [edi+764],al
 ret
generate_332_palette ENDP


.data
 MATCH_AFFINE	equ 0
 MATCH_EXACT	equ 1

 refR		dd 0
 refG		dd 0
 refB		dd 0
 difRsqr	dd 0
 difGsqr	dd 0
 difBsqr	dd 0
 match8bit	dd 0
 min_vector	dd 0
 candR		dd 0
 candG		dd 0
 candB		dd 0
 match_pal	dd 768 DUP(?)

 min_vectorf	DOUBLE ?
 cur_vector	DOUBLE ?
 difRf		DOUBLE ?
 difGf		DOUBLE ?
 difBf		DOUBLE ?
 dummyf		DOUBLE ?

 syspal label byte
  db 0,0,0,0,0,42,0,42,0,0,42,42,42,0,0,42,0,42,42,21,0,42,42,42
  db 21,21,21,21,21,63,21,63,21,21,63,63,63,21,21,63,21,63,63,63,21,63,63,63
  db 0,0,0,5,5,5,8,8,8,11,11,11,14,14,14,17,17,17,20,20,20,24,24,24
  db 28,28,28,32,32,32,36,36,36,40,40,40,45,45,45,50,50,50,56,56,56,63,63,63
  db 0,0,63,16,0,63,31,0,63,47,0,63,63,0,63,63,0,47,63,0,31,63,0,16
  db 63,0,0,63,16,0,63,31,0,63,47,0,63,63,0,47,63,0,31,63,0,16,63,0
  db 0,63,0,0,63,16,0,63,31,0,63,47,0,63,63,0,47,63,0,31,63,0,16,63
  db 31,31,63,39,31,63,47,31,63,55,31,63,63,31,63,63,31,55,63,31,47,63,31,39
  db 63,31,31,63,39,31,63,47,31,63,55,31,63,63,31,55,63,31,47,63,31,39,63,31
  db 31,63,31,31,63,39,31,63,47,31,63,55,31,63,63,31,55,63,31,47,63,31,39,63
  db 45,45,63,49,45,63,54,45,63,58,45,63,63,45,63,63,45,58,63,45,54,63,45,49
  db 63,45,45,63,49,45,63,54,45,63,58,45,63,63,45,58,63,45,54,63,45,49,63,45
  db 45,63,45,45,63,49,45,63,54,45,63,58,45,63,63,45,58,63,45,54,63,45,49,63
  db 0,0,28,7,0,28,14,0,28,21,0,28,28,0,28,28,0,21,28,0,14,28,0,7
  db 28,0,0,28,7,0,28,14,0,28,21,0,28,28,0,21,28,0,14,28,0,7,28,0
  db 0,28,0,0,28,7,0,28,14,0,28,21,0,28,28,0,21,28,0,14,28,0,7,28
  db 14,14,28,17,14,28,21,14,28,24,14,28,28,14,28,28,14,24,28,14,21,28,14,17
  db 28,14,14,28,17,14,28,21,14,28,24,14,28,28,14,24,28,14,21,28,14,17,28,14
  db 14,28,14,14,28,17,14,28,21,14,28,24,14,28,28,14,24,28,14,21,28,14,17,28
  db 20,20,28,22,20,28,24,20,28,26,20,28,28,20,28,28,20,26,28,20,24,28,20,22
  db 28,20,20,28,22,20,28,24,20,28,26,20,28,28,20,26,28,20,24,28,20,22,28,20
  db 20,28,20,20,28,22,20,28,24,20,28,26,20,28,28,20,26,28,20,24,28,20,22,28
  db 0,0,16,4,0,16,8,0,16,12,0,16,16,0,16,16,0,12,16,0,8,16,0,4
  db 16,0,0,16,4,0,16,8,0,16,12,0,16,16,0,12,16,0,8,16,0,4,16,0
  db 0,16,0,0,16,4,0,16,8,0,16,12,0,16,16,0,12,16,0,8,16,0,4,16
  db 8,8,16,10,8,16,12,8,16,14,8,16,16,8,16,16,8,14,16,8,12,16,8,10
  db 16,8,8,16,10,8,16,12,8,16,14,8,16,16,8,14,16,8,12,16,8,10,16,8
  db 8,16,8,8,16,10,8,16,12,8,16,14,8,16,16,8,14,16,8,12,16,8,10,16
  db 11,11,16,12,11,16,13,11,16,15,11,16,16,11,16,16,11,15,16,11,13,16,11,12
  db 16,11,11,16,12,11,16,13,11,16,15,11,16,16,11,15,16,11,13,16,11,12,16,11
  db 11,16,11,11,16,12,11,16,13,11,16,15,11,16,16,11,15,16,11,13,16,11,12,16
  db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	
