; File I/O routines for Tasm 4.0 / WDosX 0.96
; By Mic, 2000
;
; Please don't use fgetc() as it's kinda buggy (the buffering doesn't work).
; Don't use fputc() either, it's SLOW.


;FILE *fopen(char *filename,char mode)
; parm[edx][al]
; value[bx]
fopen PROC
 mov ah,3Dh
 int 21h
 jnc fopen_@return
  mov ax,0
 fopen_@return:
 mov bx,ax
 mov _fgetc_bufferPtr,4096
 ret
fopen ENDP


;VOID fclose(FILE *fp)
; parm[bx]
fclose PROC
 ret		;the fclose-interrupt is not available in wdosx 0.96.. 
fclose ENDP


;UINT fread(FILE *fp,VOID *buffer,UINT bytes)
; parm[bx][edx][ecx]
; value[ecx]
fread PROC
 push ebx
 push edx
 mov ah,3Fh
 int 21h
 jnc fread_@return
  mov eax,0
 fread_@return:
 pop edx
 pop ebx
 mov ecx,eax
 ret
fread ENDP


;UINT fwrite(FILE *fp,VOID *buffer,UINT bytes)
; parm[bx][edx][ecx]
; value[ecx]
fwrite PROC
 mov ah,40h
 int 21h
 jnc fwrite_@return
  mov eax,0
 fwrite_@return:
 mov ecx,eax
 ret
fwrite ENDP


;CHAR fgetc(FILE *fp)
; parm[bx]
; value[al]
fgetc PROC
 push ebx
 push ecx
 push edx
 cmp _fgetc_bufferPtr,4096
 jnge fgetc_@ptr_in_range
  mov ah,3Fh
  mov ecx,4096
  mov edx,OFFSET _fgetc_buffer
  int 21h  
  mov _fgetc_bufferPtr,0
 fgetc_@ptr_in_range:
 mov ebx,_fgetc_bufferPtr
 mov al,[_fgetc_buffer + ebx]
 mov _fgetc,al
 inc _fgetc_bufferPtr
 pop edx
 pop ecx
 pop ebx
 ret 
fgetc ENDP


;VOID fputc(FILE *fp,CHAR byte)
; parm[bx][al]
fputc PROC
 mov ah,40h
 mov ecx,1
 mov _fputc,al
 mov edx,OFFSET _fputc
 int 21h
 jnc fputc_@return
 fputc_@return:
 ret
fputc ENDP      


include dos.inc

.data
 FILE			equ <dw>	;(FILE *) type macro
 _fgetc			db 0
 _fgetc_buffer		db 4096 dup (?)
 _fgetc_bufferPtr	dd 0

 _fputc			db 0
  
